

#ifndef __SETJMP_H__
#define __SETJMP_H__

/**
 * @file setjmp.h
 * @brief Provides setjmp.h functionality.
 */

	typedef struct {
		/* Program counter.  */
		__extension__ long long __pc;

		/* Stack pointer.  */
		__extension__ long long __sp;

		/* Callee-saved registers s0 through s7.  */
		__extension__ long long __regs[8];

		/* The frame pointer.  */
		__extension__ long long __fp;

		/* The global pointer.  */
		__extension__ long long __gp;

	} __jmp_buf[1];

	typedef unsigned long int __sigset_t;

	/* Calling environment, plus possibly a saved signal mask.  */
	typedef struct __jmp_buf_tag    /* C++ doesn't like tagless structs.  */ {
		/* NOTE: The machine-dependent definitions of `__sigsetjmp'
	assume that a `jmp_buf' begins with a `__jmp_buf' and that
	`__mask_was_saved' follows it.  Do not move these members
	or add others before it.  */

	__jmp_buf __jmpbuf;		/* Calling environment.  */
	int __mask_was_saved;		/* Saved the signal mask?  */

		// we never saved the mask.
	__sigset_t __saved_mask;	/* Saved signal mask.  */

	} jmp_buf[1];

    typedef jmp_buf sigjmp_buf;
	typedef jmp_buf pj_jmp_buf;

	int pj_setjmp(pj_jmp_buf env);
	void pj_longjmp(pj_jmp_buf env, int val) __attribute__((noreturn));
	int __sigjmp_save(sigjmp_buf env, int savemask);

#endif	/* __SETJMP_H__ */

